<?php
	define ("MYSQL","MySql database");
	define ("MSACCESS","MS Acces database");
	define ("ODBC","ODBC database");

	/************************************************
	* class   database
	************************************************/
	class Database{
		var $serverType;
		var $connection;
		var $statement;
		var $result;

		function setServerType($type){
			$this->serverType = $type;
			print "Set type:\n  $type\n";
		}

		function connect($host,$user,$password){
			if ($this->serverType == MYSQL)
				$this->connection = mysql_connect($host,$user,$password);
			if ($this->serverType == ODBC)
				$this->connection = odbc_connect($host,$user,$password);
			if ($this->serverType == MSACCESS)
				$this->connection = mssql_connect($host,$user,$password);
			print "Open database.\n";
		}

		function close(){
			if ($this->connection==null) return;

			if ($this->serverType == MYSQL)
				mysql_close($this->connection);
			if ($this->serverType == ODBC)
				odbc_close($this->connection);
			print "Close connection.\n";
		}

		function free_result(){
			if ($this->connection==null) return;
			if ($this->result==null) return;

			if ($this->serverType == MYSQL)
				mysql_free_result($this->connection);
			if ($this->serverType == ODBC)
				odbc_free_result($this->connection);
			print "Free result.\n";
		}

		function get_field_name($i){
			if ($this->connection==null) return;
			if ($this->result==null) return;

			if ($this->serverType == MYSQL)
				return mysql_field_name($this->result,$i);
			if ($this->serverType == ODBC)
				return odbc_field_name($this->result,$i);
		}

		function query($statement){
			$this->statament = $statement;

			if ($this->serverType == MYSQL)
				$this->result = mysql_query($this->connection,$statement);
			if ($this->serverType == ODBC)
				$this->result = odbc_exec($this->connection,$statement);
		}

		function get_field_names(){
			$field_names = array();
			$i=0;
			while ($i < odbc_num_fields ($this->result))
				$field_names[$i++]=$this->get_field_name($i);

			return $field_names;
		}

		function get_next_record(){
			if ($this->connection==null) return;
			if ($this->result==null) return;

			if ($this->serverType == MYSQL)
				return mysql_fetch_array($this->result);
			if ($this->serverType == ODBC)
				return odbc_fetch_array($this->result);
		}


		function toXML($filename,$root,$mask){
			$field_names = array();
			$field_names = $this->get_field_names($root);

			// Create XML document
			// Set the header
			$xml_data = "<?xml version=\"1.0\" encoding=\"ISO-8859-2\"?>";
			if (func_num_args()>3)
				$xml_data.="<?xml-stylesheet type=\"text/xsl\" href=\"".func_get_arg(3)."\"?><Root>";
			while ($line = $this->get_next_record($this->result)) {
				$i=0;
				$record = "<record>";
				foreach ($line as $field_value) {
					$field = "<".$field_names[$i].">";
					if ($mask[$i]) $field.="<![CDATA[";
					$field.=$field_value;
					if ($mask[$i]) $field.="]]>";
					$field.="</".$field_names[$i++].">";
					$record.=$field;
				}
				$xml_data.=$record."</record>";
			}
			$xml_data.="</Root>";
			print $xml_data;
			if (!$hFile = fopen($filename, 'w')) {
				print "Cannot open file ($filename)";
				exit;
			}

			// Write $somecontent to our opened file.
			if (!fwrite($hFile, $xml_data)) {
				print "Cannot write to file (test.xml)";
				exit;
			}

			fclose($hFile);
		}

	}

	/************************************************
	* class   xml file 
	************************************************/

	class Xml_File{
		var $header = "";		// The full content of the XML file
		var $datas = "";		// The datacontent of the file without the header
		var $out	= "";			// The content to print to file

		// Header funtions
		function add_header(){$this->header = "<?xml version=\"1.0\" encoding=\"ISO-8859-2\"?>\n";}
		function add_stylesheet($stylesheet){
			$this->header.="<?xml-stylesheet type=\"text/xsl\" href=\"".$stylesheet."\"?>\n";
		}
		function add_doctype(){$this->header.="<!DOCTYPE conf [<!ENTITY config SYSTEM \"config.ini\">]>\n";}
		
		// Content functions
		function add_config(){$this->out = "\n\t&config;\n".$this->datas;}
		function add_root($rootname,$rootattrib){
			$this->out="<".$rootname." ".$rootattrib.">".$this->out."</".$rootname.">";}

		// Datas for FO
		function put_data($filename, $rootname, $rootattrib){
			$this->add_header();
			$this->out = $this->datas;
			$this->add_root($rootname,$rootattrib);
			$this->write_file($filename);
		}

		// Datas for HTML
		function put_content($filename, $stylesheet, $rootname, $rootattrib){
			$this->add_header();
			$this->add_stylesheet($stylesheet);
			$this->add_doctype();
			$this->add_config();
			$this->add_root($rootname,$rootattrib);
			
			$this->write_file($filename.".xml");
			
			global $config;
			$xh = xslt_create();
			if (xslt_process($xh, $filename.".xml", $config['DBViewpath']."toHTML.xslt", $filename.".html")) {
				print "Succed!\n";
			}
			else {
			    print "\nXSLT processing failed!";
			    print "\nError: " . xslt_error($xh);
			    print "\nCode : " . xslt_errno($xh);
			    exit(-1);
			}
			xslt_free($xh);
		}
		
		function write_file($filename){
			// Getting the handle to the file
			if (!$hFile = fopen($filename, 'w')) {
				print "Cannot open file ($filename)";
				exit;
			}
			// Write $xml_data to the opened file
			if (!fwrite($hFile, $this->header.$this->out)) {
				print "Cannot write to file ($filename)";
				exit;
			}
			// Closing the output
			fclose($hFile);
		}

	}



/************************************************************************/
/************************************************************************/
/************************************************************************/
function do_XMLdata($db, $transforms){
	$result="";
	// Getting parameters
	$parameters="";
	if (func_num_args()>2){
			$params = func_get_arg(2);
			$i=1;
			reset($params);
			$parameters = "PARAMETERS";
			$parameters.=" param".$i++." Text(255)='".current($params)."'";
			while(count($params)>=$i)
			{
				$parameters.=",\n param".$i++." Text(255)='".next($params)."'";
			}
			$parameters.=";\n";
	}

	// Do all querys
	foreach($transforms as $transform)
	{
		// Adding a specified text
		if ($transform['statement']=="AddNode"){
			$result .= "<".$transform['nodename'];
			$result .= " ".$transform['attributes'].">";
			$result .= $transform['nodevalue'];
			$result .= "</".$transform['nodename'].">\n";
			continue;
		}
		// Adding the current date
		if ($transform['statement']=="AddDate"){
			$result .= "\t<Date>";
			$result .= date("Y-m-d -- H:i:s");
			$result .= "</Date>\n";
			continue;
		}
		
		// Adding the current date
		if ($transform['statement']=="NewFile"){
			// New xml file
			$xml_file = new Xml_file;
		
			// Transforming result datas to xml
			$xml_file->datas = do_XMLdata($db, $transform['nested']);

			// Put the result into file	
			$xml_file->put_data($transform['filename'],$transform['rootname'],$transform['rootattrib']);
			continue;
		}
		
		// Add params to the query
		if (isset($parameters))
			$transform['statement']=$parameters.$transform['statement'];
		
		// Do the query
		$db->query($transform['statement']);

		// Getting the fieldnames
		$field_names = $db->get_field_names();

		// Set the root tag, if exists
		if (isset($transform['rootname'])) $result .= "<".$transform['rootname'];
		if (isset($transform['rootattrib'])) $result .= " ".$transform['rootattrib'];
		if (isset($transform['rootname'])) $result .= ">";

		// Transforming the datas
		while ($line = $db->get_next_record($db->result)) {
				$i=0;
				$record="";
				if (isset($transform['recordname'])) $record = "<".$transform['recordname'];
				if (isset($transform['recordattrib'])) $record .= " ".$transform['recordattrib'];
				if (isset($transform['recordname'])) $record .= ">";
				
				// Required parameters declaration
				$nested_params = array();
				$filename = "";

				// Transform record 2 xml
				foreach ($line as $field_value) {
					// Adding the begin tag
					if (isset($transform['fieldname']))
					{
						$field = "<".$transform['fieldname']." name=\"".$field_names[$i]."\"";
						if (isset($transform['attributes'])) $field.= " ".$transform['attributes'][$i].">";
						else $field .= ">";
					}
					else
					{
						$field = "<".$field_names[$i];
						if (isset($transform['attributes'])) $field.= " ".$transform['attributes'][$i].">";
						else $field .= ">";
					}
					
					// Getting the param
					if (isset($transform['parameters']))
						foreach($transform['parameters'] as $par)
							if ($field_names[$i]==$par)
								$nested_params[] = $field_value;
					
					// Getting the filename
					if (isset($transform['tofile']))
						if ($field_names[$i]==$transform['filename'])
							$filename = $field_value;

					// Adding CDATA
					if (isset($transform['mask']))
						if ($transform['mask'][$i]) $field.="<![CDATA[";
					
					// Adding the data
					$field.=$field_value;
					
					// Adding CDATA's end
					if (isset($transform['mask']))
						if ($transform['mask'][$i]) $field.="]]>";

					// Adding the end tag
					if (isset($transform['fieldname']))
						$field.="</".$transform['fieldname'].">";
					else
						$field.="</".$field_names[$i].">";

					// Adding the field to the record
					$record.=$field;
					$i++;
				}// End FOREACH
				
				// Call the function with the nested query
				if (isset($transform['nested'])){
					if (isset($transform['tofile'])){
						// Transforming result datas to xml
						$xml_file = new Xml_file;
						
						$xml_file->datas = do_XMLdata($db, $transform['nested'], $nested_params);

						// Put the result into file
						if (isset($transform['doSource']) && $transform['doSource'])
						{
							$xml_file->put_data($filename.".xml", $transform['rootname'], $transform['rootattrib']);
						}
						else
						{
							$xml_file->put_data($filename."_data.xml", $transform['rootname'], $transform['rootattrib']);
							$xml_file->put_content($filename, $transform['xslt'], $transform['rootname'], $transform['rootattrib']);
						}
					}
					else
					{
						if (isset($transform['doSource']))
							$record.= do_XMLdata($db, $transform['nested'], $nested_params);
						else
							$record.= do_XMLdata($db, $transform['nested'], $nested_params);
					}
				}// End IF

				// Adding the root endtag
				if (isset($transform['recordname'])) $record .= "</".$transform['recordname'].">";

				// Adding the record to the result
				$result .= $record;
		}// End WHILE

		// Add the roottag's end
		if (isset($transform['rootname']))
			$result.= "</".$transform['rootname'].">";
	}// End FOREACH

	return $result;
}

	function createBook(){
		$filename = "book.xml";
		$files = getFiles(".");
		print_r($files);

		// Getting the handle to the file
		if (!$hFile = fopen($filename, 'w')) {
			print "Cannot open file ($filename)";
			exit;
		}
		$content  = "<?xml version=\"1.0\" encoding=\"ISO-8859-2\"?>\n";
		$content .= "<?xml-stylesheet type=\"text/xsl\" href=\"./_DBView/toFO.xslt\"?>\n";
		$content .= "<!DOCTYPE Root [\n";
		
		$i =0;
		foreach($files as $file)
			$content .= "\t<!ENTITY element".$i++." SYSTEM \"".$file."\">\n";

		$content.= "]>\n<Book>\n";
		
		$i = 0;
		foreach($files as $file)
			$content .= "\t&element".$i++.";\n";
			
		$content .= "</Book>";
		
		// Write $content to the opened file
		if (!fwrite($hFile, $content)) {
			print "Cannot write to file ($filename)";
			exit;
		}
		// Closing the output
		fclose($hFile);
		
		// Create new XSLT processor
		$xh = xslt_create();
		
		// Create book.fo
		if (xslt_process($xh, '../book.xml', 'toFO.xslt', '../book.fo')) {
		    print "Succed!\n";
		}
		else {
		    print "XSLT processing failed!";
		    print "Error: " . xslt_error($xh);
		    print "Code : " . xslt_errno($xh);
		    exit(-1);
		}
		xslt_free($xh);
		
		exec("fop book.fo book.pdf -c _DBView/fop-config.xml");
	}

	function getFiles($rootdir){
		$files = array();
		$root = opendir($rootdir);
		// Iterate content of the directory
		while (false !== ($file = readdir($root))) { 
			if ($file != "." && $file != ".."){
				// Step into child directories
				if (is_dir($rootdir."/".$file))
					$files = append($files,getFiles($rootdir."/".$file));
				// Add data files to an array
				if (strpos($file,"_data.xml"))
					$files[]=$rootdir."/".$file;
			}
		}
		closedir($root);
		return $files;
	}
	
	// Help function, appending arrays
	function append($a1, $a2){
		$ret = array();
		foreach($a1 as $item) $ret[] = $item;
		foreach($a2 as $item) $ret[] = $item;
		return $ret;
	}

?>