<?xml version="1.0" encoding="ISO-8859-2"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:output method="xml" encoding="ISO-8859-2"/>

	<xsl:template match="/">
		<fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format"
			         xmlns:fox="http://xml.apache.org/fop/extensions">

<!-- Site declarations *************************************************************************************************** -->
			<fo:layout-master-set>
				<fo:simple-page-master master-name="first">
					<fo:region-body margin-top="110mm" margin-left="50mm" margin-right="50mm"/>
					<fo:region-after extent="25mm"/>
				</fo:simple-page-master>
		
				<fo:simple-page-master master-name="index">
					<fo:region-body margin-top="25mm" margin-left="25mm" margin-right="25mm" margin-bottom="25mm"/>
					<fo:region-after extent="20mm"/>
				</fo:simple-page-master>
				
				<fo:simple-page-master master-name="site">
					<fo:region-body margin-left="25mm" margin-right="25mm" margin-top="20mm" margin-bottom="25mm"/>
					<fo:region-before extent="20mm"/>
					<fo:region-after extent="20mm"/>
				</fo:simple-page-master>
			</fo:layout-master-set>

			<!-- Creating bookmarks **************************************************************************************-->
			<!--xsl:for-each select="Book/Site">
				<fox:outline>
					<xsl:attribute name="internal-destination">sec<xsl:number value="position()"/></xsl:attribute>
					<fox:label>
						<xsl:value-of select="Title/@text1"/><xsl:value-of select="Title/Record/Field"/><xsl:value-of select="Title/@text2"/>
					</fox:label>
				</fox:outline>
			</xsl:for-each-->
			<!--xsl:for-each select="Book/Index">
				<fox:outline>
					<xsl:attribute name="internal-destination"><xsl:value-of select="Table/@name"/></xsl:attribute>
					<fox:label>
						<xsl:value-of select="Table/@name"/>
					</fox:label>
				</fox:outline>
			</xsl:for-each-->
			<!--xsl:for-each select="Book/Site">
				<fox:outline>
					<xsl:attribute name="internal-destination"><xsl:value-of select="Table/@name"/></xsl:attribute>
					<fox:label>
						<xsl:value-of select="Table/@name"/>
					</fox:label>
				</fox:outline>
			</xsl:for-each-->
			

			<fo:page-sequence master-reference="first">
				<fo:static-content flow-name="xsl-region-after"  margin-right="25mm" text-align="right">
					<fo:block>Generated by DBView</fo:block>
					<fo:block><xsl:value-of select="/Book/Site[@type='firstPage']/Date"/></fo:block>
				</fo:static-content>

				<fo:flow flow-name="xsl-region-body">
					<fo:block text-align="center" font-size="22pt" font-weight="bold" font-family="Arial">
						<xsl:value-of select="/Book/Site[@type='firstPage']/Title/@text1"/>
					</fo:block>
				</fo:flow>
			</fo:page-sequence>
			
			<xsl:for-each select="Book/Site">
				<xsl:call-template name="Sites"/>
			</xsl:for-each>			
			
		</fo:root>
	</xsl:template>

		
	<xsl:template name="index">
		<fo:page-sequence master-reference="index">
			<fo:flow flow-name="xsl-region-body">
				<fo:block space-before="5mm" font-family="Arial">
					<!--xsl:attribute name="id"><xsl:value-of select="Table/@name"/></xsl:attribute-->
					<xsl:value-of select="/Book/Site[@type='firstPage']/Title"/>
				</fo:block>
				<fo:block  space-before="5mm" font-family="Arial">
					<xsl:apply-templates select="Table"/>
				</fo:block>
			</fo:flow>
		</fo:page-sequence>
	</xsl:template>
	
	<xsl:template name="site">
		<!--xsl:for-each select="."-->
			<fo:page-sequence master-reference="site">
				<!--********************* SITE HEADER *******************************************************************************-->
				<fo:static-content flow-name="xsl-region-before">
					<fo:block margin-left="20mm" space-before="5mm" margin-right="20mm" margin-bottom="5mm"
								border-bottom-color="black" border-bottom-style="solid" border-bottom-width="0.3mm"
								font-family="Arial">
						<xsl:value-of select="/Book/Site[@type='firstPage']/Title"/>
					</fo:block>
				</fo:static-content>
				
				<fo:static-content flow-name="xsl-region-after">
					<fo:table table-layout="fixed" width="100%">
						<fo:table-column column-width="proportional-column-width(1)"/>
						<fo:table-body>
							<fo:table-row>
								<fo:table-cell text-align="center" padding-top="5mm">
									<fo:block>- &lt; <fo:page-number/> &gt; -</fo:block>
								</fo:table-cell>
							</fo:table-row>
						</fo:table-body>
					</fo:table>
				</fo:static-content>
				
				<fo:flow flow-name="xsl-region-body">
					<fo:block text-align="center"  font-size="20pt" space-after="10mm"
								border-width="0.5mm" border-style="groove" border-color="#000000"
								background-color="#CCCCCC"
								font-family="Arial">
						<!--xsl:attribute name="id">sec<xsl:number value="position()"/></xsl:attribute-->

						<xsl:value-of select="Title/@text1"/>
						<xsl:value-of select="Title/Record/Field"/>
						<xsl:value-of select="Title/@text2"/>
					</fo:block>
					<fo:block font-family="Arial">
						<xsl:apply-templates select=".//Enumeration | .//Table"/>
					</fo:block>
				</fo:flow>
				
			</fo:page-sequence>
		<!--/xsl:for-each-->
	</xsl:template>
	
	<xsl:template match="Table">
		<fo:block space-after="10mm" >
			<fo:table table-layout="fixed" 
						border-style="solid"
						border-color="black" 
						width="100%">
				<xsl:for-each select="./Record[1]/Field | ./Record[1]/Links">
					<xsl:if test="not(contains(@type,'invisible'))">
						<fo:table-column>
							<xsl:choose>
								<xsl:when test="contains(@class,'description')">
									<xsl:attribute name="column-width">60mm</xsl:attribute>
								</xsl:when>
								<xsl:when test="contains(@class,'version')">
									<xsl:attribute name="column-width">15mm</xsl:attribute>
								</xsl:when>
								<xsl:otherwise>
									<xsl:attribute name="column-width">proportional-column-width(1)</xsl:attribute>
								</xsl:otherwise>
							</xsl:choose>
						</fo:table-column>
					</xsl:if>
				</xsl:for-each>
				<xsl:if test="count(Record)=0">
					<fo:table-column column-width="proportional-column-width(1)"/>
				</xsl:if>
				<fo:table-header border-bottom-color="black" border-bottom-width="0.5mm" border-bottom-style="solid"
									background-color="#aaaaaa">
					<xsl:if test="@name">
						<fo:table-row>
							<fo:table-cell padding-left="2mm" padding-top="2mm" padding-bottom="1mm" padding-right="2mm"
											font-size="14pt" font-weight="bold">
								<xsl:attribute name="number-columns-spanned"><xsl:value-of select="count(./Record[1]/Field)"/></xsl:attribute>
								<fo:block><xsl:value-of select="@name"/></fo:block>
							</fo:table-cell>
						</fo:table-row>
					</xsl:if>
					<xsl:call-template name="header"/>
				</fo:table-header>
				<fo:table-body>
					<xsl:for-each select="Record">
						<fo:table-row>
							<xsl:apply-templates select="."/>
						</fo:table-row>
					</xsl:for-each>
					<xsl:if test="count(Record)=0">
						<fo:table-row>
							<fo:table-cell	padding-left="3mm" padding-top="3mm"
											border-bottom-color="black" border-bottom-width="0.2mm" border-bottom-style="dashed"
											font-size="9pt">
								<fo:block>res</fo:block>
							</fo:table-cell>
						</fo:table-row>
					</xsl:if>
				</fo:table-body>
			</fo:table>
		</fo:block>
	</xsl:template>
	
	<xsl:template match="Record">
		<xsl:apply-templates select="Field | Links"/>		
	</xsl:template>
	
	<xsl:template match="Links">
		<fo:table-cell padding-left="3mm" padding-top="3mm"
							border-bottom-color="black" border-bottom-width="0.2mm" border-bottom-style="dashed"
							font-size="9pt">
			<fo:block>
				<xsl:for-each select="Record">
					<xsl:value-of select="Field"/><xsl:if test="not(position()=last())">, </xsl:if>
				</xsl:for-each>
			</fo:block>
		</fo:table-cell>
	</xsl:template>
	
	<xsl:template match="Field">
		<xsl:if test="not(contains(@type,'invisible'))">
			<fo:table-cell padding-left="3mm" padding-top="3mm"
							border-bottom-color="black" border-bottom-width="0.2mm" border-bottom-style="dashed"
							font-size="9pt">
				<!-- Adding styles (CSS) -->
				<xsl:if test="contains(@class,'description')">
					<xsl:attribute name="font-style">oblique</xsl:attribute>
					<xsl:attribute name="width">10mm</xsl:attribute>
				</xsl:if>
				<xsl:if test="contains(@class,'text')">
					<xsl:attribute name="font-weight">bold</xsl:attribute>
					<xsl:attribute name="font-size">9pt</xsl:attribute>
					<xsl:attribute name="font-style">oblique</xsl:attribute>
				</xsl:if>
				<fo:block><xsl:value-of select="."/></fo:block>
			</fo:table-cell>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="header">
		<fo:table-row border-style="solid" border-color="black" border-bottom-width="2mm">
			<xsl:for-each select="Record[1]/Field">
				<xsl:if test="not(contains(@type,'invisible'))">
					<fo:table-cell padding-left="2mm" padding-top="1mm" padding-bottom="0mm" padding-right="2mm"
									font-size="11pt" font-weight="bold"
									display-align="after">
						<fo:block>
							<xsl:value-of select="@name"/>
						</fo:block>
					</fo:table-cell>
				</xsl:if>
			</xsl:for-each>
		</fo:table-row>
	</xsl:template>
	
	<xsl:template match="Enumeration">
		<fo:block space-after="10mm">
			<fo:table table-layout="fixed" 
						border-top-width="1mm" border-right-width="1mm" border-bottom-width="1mm" border-left-width="1mm"
						border-style="solid"
						width="100%">
				<fo:table-column column-width="35mm"/>
				<fo:table-column column-width="proportional-column-width(2)"/>
				<fo:table-header border-bottom-color="black" border-bottom-width="1mm" border-bottom-style="solid">
					<fo:table-row>
						<fo:table-cell number-columns-spanned="2" background-color="#aaaaaa">
							<fo:block font-size="13pt" font-weight="bold"><xsl:value-of select="@name"/></fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-header>
				<fo:table-body>
					<xsl:for-each select="Record/Field">
						<fo:table-row>
							<fo:table-cell border-bottom-color="black" border-bottom-width="0.2mm" border-bottom-style="solid"
											border-right-color="black" border-right-width="1mm" border-right-style="solid"
											 background-color="#aaaaaa">
								<fo:block font-size="12pt" font-weight="bold" margin="2mm" padding="0.5mm"><xsl:value-of select="@name"/></fo:block>
							</fo:table-cell>
							<xsl:apply-templates select="."/>
						</fo:table-row>
					</xsl:for-each>
				</fo:table-body>
			</fo:table>
		</fo:block>
	</xsl:template>
	
	<xsl:template name="Sites">
		<xsl:if test="contains(@type,'site')">
			<xsl:call-template name="site"/>
		</xsl:if>
		<xsl:if test="contains(@type,'index')">
			<xsl:call-template name="index"/>
		</xsl:if>
	</xsl:template>
	
</xsl:stylesheet>
